-- ------------.----------------------------------
-- ESO Gear Exchange:	Trade/Sell/Giveaway your gear
-- Author:				SirAndy
-- Last Updated:		2016/11/28
-- Contact:				http://thesidekickorder.com/bbs2/index.php
--
-- NOTE:
-- Best viewed with TABs set to 4
-- TODO items are marked with $$$
-- ----------------------------------------------

EGX = {}
EGX.DisplayVersion	= "1.7.1"
EGX.Author			= "SirAndy"
EGX.SaveVersion		= 1
EGX.SavedVars		= {}
EGX.sCurUser		= "@Unknown"
EGX.sCurChar		= "Player"
EGX.isLoading		= true
EGX.isActive		= false
EGX.EXPORT			= nil

-- ----------------------------------------------
-- GLOBAL constants
-- ----------------------------------------------
EGX_COL_WHITE			= ZO_ColorDef:New("FFFFFF")
EGX_COL_RED				= ZO_ColorDef:New("FF0000")
EGX_COL_GREEN			= ZO_ColorDef:New("00FF00")
EGX_COL_BLUE			= ZO_ColorDef:New("0000FF")
EGX_COL_LIGHT_BLUE		= ZO_ColorDef:New("828EFD")
EGX_COL_MAGENTA			= ZO_ColorDef:New("FF0088")
EGX_COL_YELLOW			= ZO_ColorDef:New("F0C300")

-- ----------------------------------------------
-- GLOBAL variables, declared local for speed
-- ----------------------------------------------
local EGX_CHAT_PREFIX			= "|cF0C300EGX:|r "

local EGX_BAG_LIST = {
	BAG_WORN, BAG_BACKPACK, BAG_BANK, BAG_GUILDBANK, BAG_BUYBACK, BAG_VIRTUAL, BAG_TRANSFER
}

local EGX_ITEM_QUALITY = {
	[0] = "TRASH", [1] = "NORMAL (White)", [2] = "MAGIC (Green)", [3] = "ARCANE (Blue)", [4] = "ARTIFACT (Purple)",
	[5] = "LEGENDARY (Gold)"
}

local EGX_ARMOR_TYPE = {
	[0] = "NONE", [1] = "LIGHT", [2] = "MEDIUM", [3] = "HEAVY"
}

local EGX_WEAPON_TYPE = {
	[0] = "NONE", [1] = "AXE", [2] = "HAMMER", [3] = "SWORD", [4] = "TWO_HANDED_SWORD", [5] = "TWO_HANDED_AXE",
	[6] = "TWO_HANDED_HAMMER", [7] = "PROP", [8] = "BOW", [9] = "HEALING_STAFF", [10] = "RUNE", [11] = "DAGGER",
	[12] = "FIRE_STAFF", [13] = "FROST_STAFF", [14] = "SHIELD", [15] = "LIGHTNING_STAFF"
}

local EGX_EQUIP_TYPE = {
	[0] = "NONE", [1] = "HEAD", [2] = "NECK", [3] = "CHEST", [4] = "SHOULDERS", [5] = "ONE_HAND",
	[6] = "TWO_HAND", [7] = "OFF_HAND", [8] = "WAIST", [9] = "LEGS", [10] = "FEET", [11] = "COSTUME",
	[12] = "RING", [13] = "HAND", [14] = "MAIN_HAND", [15] = "POISON"
}

local EGX_ITEM_TYPE = {
	[0] = "NONE", [1] = "WEAPON", [2] = "ARMOR", [3] = "PLUG", [4] = "FOOD", [5] = "TROPHY", [6] = "SIEGE",
	[7] = "POTION", [8] = "RACIAL_STYLE_MOTIF", [9] = "TOOL", [10] = "INGREDIENT", [11] = "ADDITIVE", [12] = "DRINK",
	[13] = "COSTUME", [14] = "DISGUISE", [15] = "TABARD", [16] = "LURE", [17] = "RAW_MATERIAL", [18] = "CONTAINER",
	[19] = "SOUL_GEM", [20] = "GLYPH_WEAPON", [21] = "GLYPH_ARMOR", [22] = "LOCKPICK", [23] = "WEAPON_BOOSTER",
	[24] = "ARMOR_BOOSTER", [25] = "ENCHANTMENT_BOOSTER", [26] = "GLYPH_JEWELRY", [27] = "SPICE", [28] = "FLAVORING",
	[29] = "RECIPE", [30] = "POISON", [31] = "REAGENT", [32] = "DEPRECATED", [33] = "POTION_BASE", [34] = "COLLECTIBLE",
	[35] = "BLACKSMITHING_RAW_MATERIAL", [36] = "BLACKSMITHING_MATERIAL", [37] = "WOODWORKING_RAW_MATERIAL",
	[38] = "WOODWORKING_MATERIAL", [39] = "CLOTHIER_RAW_MATERIAL", [40] = "CLOTHIER_MATERIAL", [41] = "BLACKSMITHING_BOOSTER",
	[42] = "WOODWORKING_BOOSTER", [43] = "CLOTHIER_BOOSTER", [44] = "STYLE_MATERIAL", [45] = "ARMOR_TRAIT",
	[46] = "WEAPON_TRAIT", [47] = "AVA_REPAIR", [48] = "TRASH", [49] = "SPELLCRAFTING_TABLET", [50] = "MOUNT",
	[51] = "ENCHANTING_RUNE_POTENCY", [52] = "ENCHANTING_RUNE_ASPECT", [53] = "ENCHANTING_RUNE_ESSENCE", [54] = "FISH",
	[55] = "CROWN_REPAIR", [56] = "TREASURE", [57] = "CROWN_ITEM", [58] = "POISON_BASE", [59] = "DYE_STAMP"
}

local EGX_ITEM_TYPE_SPECIAL = {
	[0] = "NONE", [1] = "FOOD_MEAT", [2] = "FOOD_FRUIT", [3] = "FOOD_VEGETABLE", [4] = "FOOD_SAVOURY", [5] = "FOOD_RAGOUT", [6] = "FOOD_ENTREMET",
	[7] = "FOOD_GOURMET", [8] = "FOOD_UNIQUE",
	
	[20] = "DRINK_ALCOHOLIC", [21] = "DRINK_TEA", [22] = "DRINK_TONIC", [23] = "DRINK_LIQUEUR",
	[24] = "DRINK_TINCTURE", [25] = "DRINK_CORDIAL_TEA", [26] = "DRINK_DISTILLATE", [27] = "DRINK_UNIQUE",
	
	[40] = "INGREDIENT_MEAT", [41] = "INGREDIENT_VEGETABLE",
	[42] = "INGREDIENT_FRUIT", [43] = "INGREDIENT_FOOD_ADDITIVE", [44] = "INGREDIENT_ALCOHOL", [45] = "INGREDIENT_TEA",
	[46] = "INGREDIENT_TONIC", [47] = "INGREDIENT_DRINK_ADDITIVE", [48] = "INGREDIENT_RARE",
	
	[60] = "RACIAL_STYLE_MOTIF_BOOK", [61] = "RACIAL_STYLE_MOTIF_CHAPTER",
	
	[80] = "COLLECTIBLE_RARE_FISH", [81] = "COLLECTIBLE_MONSTER_TROPHY",
	
	[100] = "TROPHY_TREASURE_MAP", [101] = "TROPHY_SURVEY_REPORT", [102] = "TROPHY_KEY_FRAGMENT", [103] = "TROPHY_MUSEUM_PIECE",
	[104] = "TROPHY_RECIPE_FRAGMENT", [105] = "TROPHY_SCROLL", [106] = "TROPHY_MATERIAL_UPGRADER", [107] = "TROPHY_KEY",
	
	[150] = "REAGENT_HERB", [151] = "REAGENT_FUNGUS", [152] = "REAGENT_ANIMAL_PART"
}

local EGX_TRAIT_TYPE = {
	[0] = "NONE", [1] = "WEAPON_POWERED", [2] = "WEAPON_CHARGED", [3] = "WEAPON_PRECISE", [4] = "WEAPON_INFUSED",
	[5] = "WEAPON_DEFENDING", [6] = "WEAPON_TRAINING", [7] = "WEAPON_SHARPENED", [8] = "WEAPON_DECISIVE",
	[9] = "WEAPON_INTRICATE", [10] = "WEAPON_ORNATE", [11] = "ARMOR_STURDY", [12] = "ARMOR_IMPENETRABLE",
	[13] = "ARMOR_REINFORCED", [14] = "ARMOR_WELL_FITTED", [15] = "ARMOR_TRAINING", [16] = "ARMOR_INFUSED", 
	[17] = "ARMOR_PROSPEROUS", [18] = "ARMOR_DIVINES", [19] = "ARMOR_ORNATE", [20] = "ARMOR_INTRICATE", 
	[21] = "JEWELRY_HEALTHY", [22] = "JEWELRY_ARCANE", [23] = "JEWELRY_ROBUST", [24] = "JEWELRY_ORNATE", 
	[25] = "ARMOR_NIRNHONED", [26] = "WEAPON_NIRNHONED", [27] = "SPECIAL_STAT"
}

local EGX_ITEM_STYLE = {
	[0] = "NONE", [1] = "RACIAL_BRETON", [2] = "RACIAL_REDGUARD", [3] = "RACIAL_ORC", [4] = "RACIAL_DARK_ELF",
	[5] = "RACIAL_NORD", [6] = "RACIAL_ARGONIAN", [7] = "RACIAL_HIGH_ELF", [8] = "RACIAL_WOOD_ELF", [9] = "RACIAL_KHAJIIT",
	[10] = "UNIQUE", [11] = "ORG_THIEVES_GUILD", [12] = "ORG_DARK_BROTHERHOOD", [13] = "DEITY_MALACATH", [14] = "AREA_DWEMER",
	[15] = "AREA_ANCIENT_ELF", [16] = "DEITY_AKATOSH", [17] = "AREA_REACH", [18] = "ENEMY_BANDIT", [19] = "ENEMY_PRIMITIVE",
	[20] = "ENEMY_DAEDRIC", [21] = "DEITY_TRINIMAC", [22] = "AREA_ANCIENT_ORC", [23] = "ALLIANCE_DAGGERFALL",
	[24] = "ALLIANCE_EBONHEART", [25] = "ALLIANCE_ALDMERI", [26] = "UNDAUNTED", [27] = "RAIDS_CRAGLORN", [28] = "GLASS",
	[29] = "AREA_XIVKYN", [30] = "AREA_SOUL_SHRIVEN", [31] = "ENEMY_DRAUGR", [32] = "ENEMY_MAORMER", [33] = "AREA_AKAVIRI",
	[34] = "RACIAL_IMPERIAL", [35] = "AREA_YOKUDAN", [36] = "UNIVERSAL", [37] = "AREA_REACH_WINTER", [38] = "ORG_WORM_CULT",
	[39] = "ENEMY_MINOTAUR", [40] = "EBONY", [41] = "ORG_ABAHS_WATCH", [42] = "ENEMY_SKINCHANGER", [43] = "ORG_MORAG_TONG",
	[44] = "AREA_RA_GADA", [45] = "ENEMY_DROMOTHRA", [46] = "ORG_ASSASSINS", [47] = "ORG_OUTLAW", [48] = "UNUSED11",
	-- $$$ NOTE: 53,57,58,59 are not yet exported on esodata.uesp.net for API 100017 but the display style names are known
	-- $$$ NOTE: UNUSED17 is actually used by the "Red Mountain" set!
	[49] = "UNUSED12", [50] = "UNUSED13", [51] = "UNUSED14", [52] = "UNUSED15", [53] = "STALHRIM_FROSTCASTER", [54] = "UNUSED17",
	[55] = "UNUSED18", [56] = "UNUSED19", [57] = "GRIM_HARLEQUIN", [58] = "GRIM_HARLEQUIN", [59] = "HOLLOWJACK"
}

-- ----------------------------------------------
-- Trim() whitespaces from a String
-- ----------------------------------------------
local function trim(s)
	local a = s:match('^%s*()')
	local b = s:match('()%s*$', a)
	return s:sub(a,b-1)
end

-- ----------------------------------------------
-- Split String by separator and return an array
-- ----------------------------------------------
local function split(s, sep)

	if (s == nil) then return nil end
	if (sep == nil) then sep = "%s" end

	s = trim(s)
	if (s == "") then return nil end

	local t = {}
	local i = 1
	for str in string.gmatch(s, "([^"..sep.."]+)") do
		-- d("t[" .. i .."]: " .. str)
		t[i] = str
		i = i + 1
	end

	return t
end

-- ----------------------------------------------
-- Print an info String to the console
-- ----------------------------------------------
local function infPrint(s)

	-- $$$ Check for the pChat AddOn
	-- If present, do *NOT* use nested chat color coding, otherwise ESO will crash and burn!
	if (not pChat) then
		d(EGX_COL_LIGHT_BLUE:Colorize(s))
	else
		d(s)
	end
end

-- ----------------------------------------------
-- Print an error String to the console
-- ----------------------------------------------
local function errPrint(s)

	-- $$$ Check for the pChat AddOn
	-- If present, do *NOT* use nested chat color coding, otherwise ESO will crash and burn!
	if (not pChat) then
		d(EGX_COL_RED:Colorize(string.format("EGX.ERROR: %s",s)))
	else
		d(string.format("|cFF0000EGX.ERROR:|r %s",s))
	end
end

-- ----------------------------------------------
-- Print a debug String to the console
-- ----------------------------------------------
local function dbgPrint(s)

	-- $$$ Check for the pChat AddOn
	-- If present, do *NOT* use nested chat color coding, otherwise ESO will crash and burn!
	if (not pChat) then
		d(EGX_COL_YELLOW:Colorize(s))
	else
		d(s)
	end
end

-- ----------------------------------------------
-- OnLoad()
-- ----------------------------------------------
function EGX.OnLoad(eventCode, addOnName)

	if addOnName ~= "ESOGearExchange" then return end
	EVENT_MANAGER:UnregisterForEvent("EGX_StartUp", EVENT_ADD_ON_LOADED)

	local defaults = {}
	EGX.sCurUser = GetDisplayName()
	EGX.sCurChar = GetUnitName("player")

	-- This ensures that our SavedVariables data tree is created if it doesn't already exists.
	EGX.SavedVars["info"] = ZO_SavedVars:NewAccountWide("ESOGearExchange_Vars", EGX.SaveVersion, "info", defaults)

	-- Create the export section and add the header info
	if (_G["ESOGearExchange_Vars"]["Default"][EGX.sCurUser]["$AccountWide"]["export"] == nil) then
		_G["ESOGearExchange_Vars"]["Default"][EGX.sCurUser]["$AccountWide"]["export"] = {}
	end
	EGX.SavedVars["export"] = _G["ESOGearExchange_Vars"]["Default"][EGX.sCurUser]["$AccountWide"]["export"]
	EGX.EXPORT = EGX.SavedVars["export"]
	
	-- Always rewrite the header in case the format has changed
	EGX.EXPORT["data|header"] =
		"Name|Type|Count|Level|Champion|Quality|Trait|Bound|Armor|Weapon|Style|Price|Slot|Special|Id|Icon|"

	EVENT_MANAGER:RegisterForEvent("EGX_PlayerActivated", EVENT_PLAYER_ACTIVATED, EGX.OnPlayerActivated)

	EGX.isLoading = false
end

-- ----------------------------------------------
-- OnPlayerActivated()
-- ----------------------------------------------
function EGX.OnPlayerActivated(eventCode)

	if (EGX.isLoading or EGX.isActive) then return end
	EGX.isActive = true

	-- Say hello ...
	infPrint(string.format(
		"%sAddOn loaded for %s",
		EGX_CHAT_PREFIX,
		EGX_COL_MAGENTA:Colorize(EGX.sCurChar)
	))
	infPrint(string.format(
		"%sType %s for more info ...",
		EGX_CHAT_PREFIX,
		EGX_COL_WHITE:Colorize("/egx")
	))

end

-- ----------------------------------------------
-- Parse the /egx slash commands
-- ----------------------------------------------
SLASH_COMMANDS["/egx"] = function(sCmdLine)
local didProcess, sCmd, opt1, opt2

	dbgPrint("EGX: CMD(): "..sCmdLine)

	-- Parse the command string and tokenize it
	sCmd	= ""
	opt1	= ""
	opt2	= ""
	tokens	= split(sCmdLine)
	if (tokens ~= nil) then
		sCmd = string.lower(tokens[1])
		if (tokens[2] ~= nil) then opt1 = string.lower(tokens[2]) end
		if (tokens[3] ~= nil) then opt2 = string.lower(tokens[3]) end
	else
		sCmd = string.lower(sCmdLine)
	end
	didProcess	= false

	if (sCmd ~= "") then

		-- List all (useful) bags
		if (sCmd == "bags") then
			infPrint("EGX: Bags:")
			infPrint(string.format("BAG Equipped = %d",		GetNumBagUsedSlots(BAG_WORN)))
			infPrint(string.format("BAG Inventory = %d/%d",	GetNumBagUsedSlots(BAG_BACKPACK),	GetBagSize(BAG_BACKPACK)))
			infPrint(string.format("BAG Bank = %d/%d",		GetNumBagUsedSlots(BAG_BANK),		GetBagSize(BAG_BANK)))
			infPrint(string.format("BAG Craft = %d",		GetNumBagUsedSlots(BAG_VIRTUAL)))
			didProcess = true
		end
		
		if ((sCmd == "list") or (sCmd == "export")) then

			local soutchat = ""
			local doExport = false
			
			if (sCmd == "export") then doExport = true end

			-- List/export all equipped items
			if ((opt1 == "equ") or (opt1 == "equipped")) then
				soutchat = string.format("EGX: Equipped Items[%d/%d]:", GetNumBagUsedSlots(BAG_WORN), GetBagSize(BAG_WORN))
				infPrint(soutchat)
				EGX.ListItemsInBag(BAG_WORN, doExport)
			end

			-- List/export all inventory items
			if ((opt1 == "inv") or (opt1 == "inventory")) then
				soutchat = string.format("EGX: Inventory Items[%d/%d]:", GetNumBagUsedSlots(BAG_BACKPACK), GetBagSize(BAG_BACKPACK))
				infPrint(soutchat)
				EGX.ListItemsInBag(BAG_BACKPACK, doExport)
			end

			-- List/export all bank items
			if (opt1 == "bank") then
				soutchat = string.format("EGX: Bank Items[%d/%d]:", GetNumBagUsedSlots(BAG_BANK), GetBagSize(BAG_BANK))
				infPrint(soutchat)
				EGX.ListItemsInBag(BAG_BANK, doExport)
			end

			-- List/export all crafting bag items
			if (opt1 == "craft") then
				soutchat = string.format("EGX: Craft Bag Items[%d/%d]:", GetNumBagUsedSlots(BAG_VIRTUAL), GetBagSize(BAG_VIRTUAL))
				infPrint(soutchat)
				EGX.ListItemsInBag(BAG_VIRTUAL, doExport)
			end

			if (soutchat ~= "") then
				if (doExport) then
					infPrint("> Export done, logout or /reloadui to save your data ...")
				else
					infPrint(soutchat)
				end
				didProcess = true
			end
			infPrint("___")

		end
	end
	
	if not didProcess then
		infPrint("_________________")
		infPrint("EGX Usage:")
		infPrint(" /egx cmd %1 %2")
		infPrint("_")
		infPrint(" bags -> Lists all available bags and their size")
		infPrint(" list %1 -> Lists the contents of the selected bag")
		infPrint(" export %1 -> Exports the contents of the selected bag")
	end
end

-- ----------------------------------------------
-- List/Export all items in the supplied bag
-- ----------------------------------------------
function EGX.ListItemsInBag(bagID, doExport)
local i, itemIndex, maxItems, bagKey, bagTable

	-- If export, find the correct table for the bag
	bagTable = nil
	if (doExport) then
		bagKey = "data|inventory|" .. EGX.sCurChar
		if (bagID == BAG_WORN) then		bagKey = "data|equipped|" .. EGX.sCurChar end
		if (bagID == BAG_BANK) then		bagKey = "data|bank" end
		if (bagID == BAG_VIRTUAL) then	bagKey = "data|craft_bag" end

		-- We always reset the bag table to prevent duplicate data
		EGX.EXPORT[bagKey] = {}
		bagTable = EGX.EXPORT[bagKey]
	end

	i = 1
	if (bagID ~= BAG_VIRTUAL) then
		maxItems = GetBagSize(bagID)
		for itemIndex=0, (maxItems-1), 1 do
			EGX.FormatItems(bagID, itemIndex, bagTable)
			i = i + 1
		end
	else
		itemIndex = GetNextVirtualBagSlotId(nil)
		while itemIndex ~= nil do
			EGX.FormatItems(bagID, itemIndex, bagTable)
			i = i + 1
			itemIndex = GetNextVirtualBagSlotId(itemIndex)
		end
	end
end

-- ----------------------------------------------
-- Gets the Item ID from the supplied link
-- ----------------------------------------------
function EGX.GetIdFromLink(itemLink)

	local itemID	= string.sub(itemLink, 10)
	local sep		= string.find(itemID, ":") - 1
	if (sep ~= nil) then
		itemID = tonumber(string.sub(itemID, 1, sep))
	else
		itemID = 0
	end
	
	return itemID
end

-- ----------------------------------------------
-- Formats the item info and prints it to console or writes it to file
-- ----------------------------------------------
function EGX.FormatItems(bagID, itemIndex, bagTable)
local icon, stackCount, sellPrice, meetsUsageRequirements, locked, equipType, itemStyle, quality
local itemLevel, championPoints, armorType, itemType, specializedItemType, itemInfo
local itemName, itemID, itemLink, weaponType, itemTrait, isBound, bagKey

	icon, stackCount, sellPrice, meetsUsageRequirements, locked, equipType, itemStyle, quality = GetItemInfo(bagID, itemIndex)
	if (stackCount > 0) then
		if (bagTable) then
			itemType, specializedItemType = GetItemType(bagID, itemIndex)
			armorType		= GetItemArmorType(bagID, itemIndex)
			weaponType		= GetItemWeaponType(bagID, itemIndex)
			itemTrait		= GetItemTrait(bagID, itemIndex)
			isBound			= IsItemBound(bagID, itemIndex)
			--itemName		= GetItemName(bagID, itemIndex)
			itemName		= zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemName(bagID, itemIndex))
		end
		
		itemLink		= GetItemLink(bagID, itemIndex, LINK_STYLE_BRACKETS)
		itemLevel		= GetItemRequiredLevel(bagID, itemIndex)
		championPoints	= GetItemRequiredChampionPoints(bagID, itemIndex)
		itemID			= EGX.GetIdFromLink(itemLink)
		itemInfo		= ""

		if (bagTable) then
			-- "Name|Type|Count|Level|Champion|Quality|Trait|Bound|Armor|Weapon|Style|Price|Slot|Special|Icon|"
			itemInfo = string.format("%s|%s|%d|%d|%d|%s|%s|%s|%s|%s|%s|%d|%s|%s|%d|%s|",
				itemName, EGX_ITEM_TYPE[itemType], stackCount, itemLevel, championPoints, EGX_ITEM_QUALITY[quality],
				EGX_TRAIT_TYPE[itemTrait], tostring(isBound), EGX_ARMOR_TYPE[armorType], EGX_WEAPON_TYPE[weaponType],
				EGX_ITEM_STYLE[itemStyle], sellPrice, EGX_EQUIP_TYPE[equipType], EGX_ITEM_TYPE_SPECIAL[specializedItemType], itemID, icon
			)
			table.insert(bagTable, itemInfo)

		else
			itemInfo = string.format("%dx %s", stackCount, itemLink)
			if (itemLevel > 1) then
				itemInfo = itemInfo .. string.format(" L%d", itemLevel)
			end
			if (championPoints > 0) then
				itemInfo = itemInfo .. string.format(" CP%d", championPoints)
			end
			-- if (sellPrice > 0) then
			-- 	itemInfo = itemInfo .. string.format(" g|cF0C300%d|r ", (sellPrice * stackCount))
			-- end
			-- itemInfo = itemInfo .. " |c828EFDid=|c888888" .. itemID .. "|r"
			infPrint(itemInfo)
		end
	end
end

-- ----------------------------------------------
-- Initial Event Manager Hooks
-- ----------------------------------------------
EVENT_MANAGER:RegisterForEvent("EGX_StartUp", EVENT_ADD_ON_LOADED, EGX.OnLoad)

